<?php
require_once 'Indicadores.php';
require_once 'Proxies/ProxyIndicadores/ProxyAtencion.php';
class Atencion extends Indicadores
{

    private $ninos = array(0, 0); // nino nina
    private $casas = array(0, 0, 0); //zimapan meson libertad
    private $edades = array('e0'=>0,'e1' => 0, 'e2' => 0, 'e3' => 0, 'e4' => 0, 'e5' => 0, 'e6' => 0, 'e7' => 0, 'e8' => 0, 'e9' => 0, 'e10' => 0, 'e11' => 0, 'e12' => 0, 'e13' => 0, 'e14' => 0, 'e15' => 0, 'e16' => 0);
    private $capacidadInstalada = 0;
    private $casaArray = array();
    private $totalEgresadoPorYear = 0;
    private $totalEgresadoPorYearSumatoria = 0;
    private $totalActivosEdad = array();
    private $datos_beneficiario= array();
    private $datos_beneficiario_dos= array();
    private $datos_beneficiario_totales=array();

   
    private $total = 0;

    private $resultadoFinalYear = array();
    private $resultadoFinal=array();


  
    public function __construct()
    {
        parent::__construct();
        $this->proxy = new ProxyAtencion();
    }

    public function informacion($datos)
    {
        foreach ($datos as $dato) {
            $this->grupoAtencion($dato);
        }
      //  echo var_dump($this->totalEgresadoPorYear);
    }

    public function grupoAtencion($year)
    {
        $this->proxy->getTotalBeneficiariosToshi($year);
        //    var_dump($this->proxy->getResultado()); echo "<br><br>";

        $this->proxy->getTotalBeneficiariosActuales($year);
        $resultadoActual = $this->proxy->getResultado();
    
        $this->proxy->getTotalBeneficiariosActualesFalsos($year);
        $resultadoPasado = $this->proxy->getResultados();

     //   echo (($resultadoActual[0] + $resultadoPasado[0]) / 100) * 100;
        //return $resultadoPasado[1];
        //return $resultadoActual[1];
         $this->obtenerDatos($resultadoActual, $resultadoPasado, $year);

        $this->proxy->getTotalBeneficiariosEgresados($year); //Obtenemos el total de egresados de ese año y hacia atras, sumatoria.
        $this->totalEgresadoPorYearSumatoria =$this->proxy->getResultado()[0];
        $this->proxy->getTotalBeneficiariosEgresadosPorYear($year); //Obtenemos el total de egresados de ese año
        $this->totalEgresadoPorYear= $this->proxy->getResultado()[0];
        $this->capacidadInstalada= (($resultadoActual[0] + $resultadoPasado[0]) / 100) * 100;
        $this->totalActivosEdad=$this->edades;
        $this->total=$resultadoActual[0] + $resultadoPasado[0];
        $this->casaArray=$this->casas;
        $this->resultadoFinalYear=array($this->totalActivosEdad,$this->total, $this->totalEgresadoPorYear,$this->totalEgresadoPorYearSumatoria, $this->capacidadInstalada,$this->casas, $this->ninos);
        // edades/ total/ egresados/ egredados toshi para atras /capacifadd instalada/ por casa, por sexo
        array_push($this->resultadoFinal,$this->resultadoFinalYear);
      //  echo var_dump($this->resultadoFinal);
      //  echo "<br>";

      //  return $this->datos_beneficiario_dos;
        //$this->datos_beneficiario;
        array_push($this->datos_beneficiario_totales,$this->getBeneficiarios());
        $this->reinicio();
    }


    public function getTotalBeneficiarios(){
        return $this->datos_beneficiario_totales;
    }

    public function getBeneficiarios(){
        return [$this->datos_beneficiario_dos,$this->datos_beneficiario];
    }

    public function getResultado(){
        return $this->resultadoFinal;
    }

    public function  obtenerPorEdades($dato, $year)
    {
        $fecha_nacimiento = new DateTime($dato);
        $hoy = new DateTime($year . "-12-31");
        $edad = $hoy->diff($fecha_nacimiento);
    //    echo $edad->y;
        if($edad->y<=16){
            $index="e".$edad->y;
            $this->edades[$index] = $this->edades[$index] + 1;
        }
        //echo "<br>";
       
    }
    public function obtenerDatos($resultados, $resultadoDos, $year)
    {
        if ($resultados[0] != 0) {
            foreach ($resultados[1] as $resultado) {
              //  return $resultado;
                 array_push($this->datos_beneficiario,$resultado);
                $this->obtenerPorCasa($resultado['id_casa']);
                $this->obtenerNino($resultado['genero']);
             
                $this->obtenerPorEdades($resultado['fecha_nac'], $year);
            }

            foreach ($resultadoDos[1] as $resultado) {
                array_push($this->datos_beneficiario_dos,$resultado);
                $this->obtenerPorCasa($resultado['id_casa']);
                $this->obtenerNino($resultado['genero']);
            
                
                $this->obtenerPorEdades($resultado['fecha_nac'], $year);
            }
        } else {
        }
    }

    public function obtenerPorCasa($casa)
    {
        if ($casa == 1) { //zimapan
            $this->casas[0] = $this->casas[0] + 1;
        } else if ($casa == 2) { //meson
            $this->casas[1] = $this->casas[1] + 1;
        } else if ($casa == 3) { // libertad 
            $this->casas[2] = $this->casas[2] + 1;
        }
    }

    public function obtenerNino($sexo)
    {
        if ($sexo == 'M') {
            $this->ninos[0] = $this->ninos[0] + 1;
        } else if ($sexo == 'F') {
            $this->ninos[1] = $this->ninos[1] + 1;
        }
    }

    public function reinicio()
    {
        $this->resultadoFinalYear=array();
        $this->capacidadInstalada = 0;
        $this->total = 0;
        $this->totalEgresadoPorYear = 0;
        $this->totalEgresadoPorYearSumatoria = 0;
        $this->ninos = array(0, 0); // nino nina
        $this->casas = array(0, 0, 0); //zimapan meson libertad
        $this->edades = array('e0'=> 0,'e1' => 0, 'e2' => 0, 'e3' => 0, 'e4' => 0, 'e5' => 0, 'e6' => 0, 'e7' => 0, 'e8' => 0, 'e9' => 0, 'e10' => 0, 'e11' => 0, 'e12' => 0, 'e13' => 0, 'e14' => 0, 'e15' => 0, 'e16' => 0);
        $this->datos_beneficiario= array();
        $this->datos_beneficiario_dos= array();
    }
}
